/*
  3.  
 :
     N < 1000  ()  M < 2000  (). 
    ,    - .    
    ,         -
  .        :      -
 ,     ,       ,
     .        -
  ,         .  
     .        
      .

 :
      . ..     
      (,     
  )  ,         .
   ,    ,     ,  
   ,    ""      .
       ,        
  ,   ,    ,    (   
  .)  ,      -  
   -, ..         -
     (  )   
 .
        ,     
    (   ,)     
  .      , 
   ,    , ..     
        .
            
     ,    ,   
        ,    
 .
*/

#include <stdio.h>
#include <stdlib.h>

#define MAX_N 1000
#define MAX_M 2000

unsigned int height[] = { 0, 130, 110, 150, 110, 180 };  /*  */
unsigned int neigh_n[] = { 0, 1, 0, 2, 0, 3 };/*     */
unsigned neigh[][MAX_N] = {{ 0, 0, 0, 0 },         /*  */
                           { 0, 2, 0, 0 },
                           { 0, 0, 0, 0 },
                           { 0, 1, 2, 0 },
                           { 0, 0, 0, 0 },
                           { 0, 2, 3, 4 }};
double water[] = { 0, 50, 195, 40, 35, 0 };  /*    */

int n = 5 , m = 7;

int main( void )
{
  int i, j, k, l, moretodo;
/*
  scanf( "%d %d", &n, &m );
  for( i = 1; i <= n; i++ ) scanf( "%d", &height[i] );
  for( i = 0; i < m; i++ )
  {
    scanf( "%d %d %d", &j, &k, &l );
    if( height[j] > height[k] )
      water[k] += l,
      neigh[j][++neigh_n[j]] = k;
    else if( height[j] < height[k] )
    {
      water[j] += l,
      neigh[k][++neigh_n[k]] = j;
    }
    else
      water[j] += (double)l / 2,
      water[k] += (double)l / 2;
  }
*/
  for(; moretodo;)
  {
    moretodo = 0;
    for( i = 1; i <= n; i++ )
      if( neigh_n[i] && water[i] )
      {
	moretodo = 1;
	for( j = 1; j <= neigh_n[i]; j++ )
	  water[neigh[i][j]] += water[i] / neigh_n[i];
	water[i] = 0;
      }
  }

  l = 0;
  for( i = 1; i <= n; i++ )
    if( !neigh_n[i] )
    {
      if( l ) printf( "\n" );
      l = 1;
      printf( "%d %.4lf", i, water[i] );
    }

  return 0;
}
