/*
  5.  (   '97 8-9 )
 :
      1  N (  2, 3, ..., N-1   )
             
    -  -.      
 ,         1  N  
 .

 :
      .    
 dist[i][j], ( i  ,  j  .)  
  :
 dist[1][j] = min( dist[1][k] + dist[k][j] ),  k = 2, ..., j - 1
     ,    j,    from[j]  
   k  ,          ,
        .    
  ,         .  
               
   path   pp.
      ,       
     ,    -  -
  .      2   
  : F * 100 = I  F     ,  I  .
*/

#include <stdio.h>

#define MAX 100

double dist[5][5] = {{ 0, 0, 0, 0,  0 },
                     { 0, 0, 3, 9, 20 },
                     { 0, 0, 0, 7, 16 },
                     { 0, 0, 0, 0, 10 },
                     { 0, 0, 0, 0,  0 }};
int from[MAX];
int path[MAX], pp;

int n = 4;

main()
{
  int i, j;
  double v;

  for( i = 1; i <= n; from[i++] = 1 );

  for( i = 3; i <= n; i++ )
    for( j = 2; j < i; j++ )
      if( dist[1][i] > ( v = dist[1][j] + dist[j][i] ))
        dist[1][i] = v, from[i] = j;

  for( path[0] = n, pp = 1, i = n; i != 1;)
    path[pp++] = i = from[i];

  printf( "%d", --pp );
  for( i = pp; i; i-- )
    printf( "\n%d %d", path[i], path[i - 1] );
}
