{
                              
                            ----------------------

       ,    ,   , -
   HTML.       <TABLE>  
    </TABLE>.        -
    ,    . 
         <TR> ... </TR>,   
        .    
          -  . 
       1  10.       
 ,   ,    -   , -
     .      <TD>  </TD>,
      <TD>  </TD>   , 
     ,    .    , -
         ,       
    .     ,
    .       3   2 :
    <TABLE>
       <TR> <TD> 0123476789     </TD> <TD> 10       </TD> </TR>
       <TR> <TD> row2col1       </TD> <TD> kletka22 </TD> </TR>
       <TR> <TD> 202202.05pbppp </TD> <TD> row3col2 </TD> </TR>
    </TABLE>
              -
   ,    .     -
 , :        ,    
                -
            . -
      '*'.         -
         '*'   30. -
           ,  
              -
                -
 . a       ,    -
             -
      .

                                 
                                 -------
   -   :
          , :
      (1)   
      (2)           
      (3)      
    
  (1) -        .   
   -    ,       -
   ,          -
    .      , 
      .    ,   -
          .   
           ,  -
    ,   ,    ,  
  .   -     .  -
    ,  "  ".    
        .   
         .       
        .      ( -
     ),       .  -
       ,    ,     -
     '>'.       
 32KB.
   (2)          -
      .  ,  Greedy   
        ,  
  .      ,    
    ,        
   ,           
     .      , 
      1, 2  3 ,      
       ,    
           ,   
         ,   
       .    - -
      Backtracking.     
  ,      - 10   -
  30,       .  
           
   ,      - .    -
     ,        -
    .     ,   
    ,   - . 
             
      ,      -
 .        ,     -
              
     .  ,   ,  -
        ,   - -
          ,      -
           - -
 .     ,        
  '*'.        .
  (3)      .      -
        ,        
              
         ,     .
          '*'.    
    ,           -
  .
       10 sec.    , -
      500 ,    . -  -
 ,      7, 8  9 ,    -
        -.

                                                
                                            --------------------------------
                                                                
                                                          .  
                                                          tel. (062) 3-14-36
                                                   e-mail: nakov@hotmail.com
}

{$R-} {$S-} {$Q-}
CONST InFileName  = 'tables.txt';
      OutFileName = '';
      MaxLines = 1000;
      MaxCols = 10;
      MaxTextLen = 32768;
      TableSize = 30;

TYPE TKletka = record
                 Len: integer;
                 Text: array[1..MaxTextLen] of char;
               end;
     PKletka = ^TKletka;
     THeights = array[1..MaxLines] of integer;
     PHeights = ^THeights;


VAR F: Text;
    T: array[1..MaxLines,1..MaxCols] of PKletka;
    Rows,Cols: integer;

    Width,BestWidth: array[1..MaxCols] of byte;
    Height,BestHeight: THeights;


Procedure DisposeKletka(K:PKletka); {Free allocated for K memory}
  Begin with K^ do Freemem(K,Len*SizeOf(char)+SizeOf(Len)); End;

Procedure ReadTable; {Read a table from current position of input file}
Var KletkaBuf: PKletka;

  Function MyUpCase(const S: string): string;
  Var Rez: string;
      I: integer;
  Begin
    Rez:='';
    for I:= 1 to length(S) do
      Rez:= Rez + UpCase(S[I]);
    MyUpCase:=Rez;
  End;

  Function GetWord: string; {Skip separators before the word at current}
  Var Ch: char;  {position in input file and return this word or ''. We}
      S: string; {  consider every word ends with '>', separator or EOF}
  Begin
    repeat
      Read(F,Ch);
    until (not (Ch in [#10,#13,' ',#9])) or EOF(F);
    if EOF(F) then
      begin GetWord:=''; Exit; end;
    S:='';
    repeat
      S:= S + Ch;
      Read(F,Ch);
    until (Ch in [#10,#13,' ',#9,'>']) or EOF(F);
    if Ch = '>' then GetWord:= S + Ch
    else GetWord:=Ch;
  End;

  Procedure ProcessRow; {Process the text between <TR> and </TR> and fill T}

    Function GetKletkaText: PKletka;  {Return the text at current file pos.}
    Var NewKletka: PKletka; {Allocate memory for it. It can be at most 32KB}
        Ch: char;
    Begin
      Ch:=#10;
      while (not EOF(F)) and (Ch in [#10,#13,' ',#9]) do
        Read(F,Ch);
      with KletkaBuf^ do
        begin
          Len:=0;
          while (not EOF(F)) and (Ch in ['0'..'9','a'..'z','A'..'Z']) do
            begin
              Inc(Len); Text[Len]:=Ch;
              Read(F,Ch);
            end;
          GetMem(NewKletka, Len*SizeOf(char)+SizeOf(Len) );
          Move(KletkaBuf^,NewKletka^, Len*SizeOf(char)+SizeOf(Len) );
          GetKletkaText:= NewKletka;
        end;
    End;

    Function MaximalColumnCount: integer; {Return number of columns in T}
    Begin
      if Rows = 1 then MaximalColumnCount:= MaxCols
      else MaximalColumnCount:= Cols;
    End;

  Var ColCount: integer;
      KletkaText: PKletka;
      S: string;
  Begin
    ColCount:=0; Inc(Rows);
    repeat
      S:=GetWord;
      if Pos('TD',MyUpCase(S)) <> 0 then
        begin { '<TD>' found. We must get kletka contents and save it in T }
          KletkaText:= GetKletkaText;
          if ColCount < MaximalColumnCount then
            begin { We get kletka contents only if we need more kletki }
              Inc(ColCount); if Rows = 1 then Inc(Cols);
              T[Rows,ColCount]:= KletkaText;
            end
          else DisposeKletka(KletkaText);
          GetWord; { skip '</TD>' after kletka's contents}
        end;
      if Pos('TR',MyUpCase(S)) <> 0 then
        Exit; { '</TR>' found. Row completed. Exit }
    until EOF(F);
  End;

  Procedure ProcessTableBody; {Process the text between <TABLE> and </TABLE>}
  Var S: string;
  Begin
    repeat
      S:=GetWord;
      if Pos('TR',MyUpCase(S)) <> 0 then
        ProcessRow; { '<TR>' found. }
      if Pos('TABLE',MyUpCase(S)) <> 0 then
        Exit; { '</TABLE>' found. Table sucessufully loaded from file. Exit }
    until EOF(F);
  End;

Begin
  New(KletkaBuf);
  Rows:=0; Cols:=0;
  FillChar(T,SizeOf(T),0);
  if Pos('TABLE',MyUpCase(GetWord)) <> 0 then { '<TABLE>' found }
    ProcessTableBody;
  Dispose(KletkaBuf);
End;


Procedure CalculateOptimalWidthAndHeight;
Var SumRows,MinRows: longint;
    SumCols,MinCols: integer;

  Procedure FindWidths(Col,Len:integer); {Calculate optimal Widths[1..Col]}
  Var W: integer;                        {and Heights[1..Rows] and MinRows}
      H: PHeights;

    Function Max(a,b:integer): integer;
      Begin if a>b then Max:=a else Max:=b; End;

    Procedure CalculateHeights; {Using given width W of current column}
    Var R: integer;             {calculate Heights[1..Rows] and SumRows}
    Begin
      SumRows:=0;
      for R:= 1 to Rows do
        if T[R,Col] <> nil then
          begin
            Height[R]:= Max( Height[R],
                             (T[R,Col]^.Len+W-1) div W );
            Inc(SumRows,Height[R]);
          end;
    End;

  Begin
    if (SumRows > MinRows) or
       ((SumRows = MinRows) and (SumCols>=MinCols)) then
      Exit; {Exit if there isn't perspective to find better solution}
    if Col = 0 then
      begin {Better solution found. Update solution and Exit}
        BestWidth:=Width; BestHeight:=Height;
	MinRows:=SumRows; MinCols:=SumCols;
        Exit;
      end;
    for W:= 1 to Len-Col+1 do
      begin {Try all possible widths for column Col}
        GetMem(H,Rows*SizeOf(integer));
	Move(Height,H^,Rows*SizeOf(integer));
        Width[Col]:=W; CalculateHeights;
        Inc(SumCols,W);
          FindWidths(Col-1,Len-W);
        Dec(SumCols,W);
        Move(H^,Height,Rows*SizeOf(integer));
	FreeMem(H,Rows*SizeOf(integer));
      end;
  End;

Begin
  SumCols:=0; MinRows:=MaxLongInt;
  FillChar(Height,SizeOf(Height),0);
  FindWidths(Cols,TableSize-Cols-1);
End;


Procedure PrintTable;
Var Row,TotalWidth: integer;
    F: Text;

  Procedure PrintLine;
  Var I: integer;
  Begin
    for I:= 1 to TotalWidth+Cols+1 do
      Write(F,'*');
    WriteLn(F);
  End;

  Procedure PrintRow;
  Var I,R,C: integer;
  Begin
    for R:= 1 to BestHeight[Row] do
      begin {Write the row Row of the table at Heights[Row] sequential rows}
        for C:= 1 to Cols do
          begin {Write the next part of T[R,C]}
            Write(F,'*');
            with T[Row,C]^ do
              for I:= (R-1)*BestWidth[C]+1 to R*BestWidth[C] do
                if ((T[Row,C])=nil) or (I > Len) then Write(F,' ')
                else Write(F, Text[I]);
          end;
        WriteLn(F,'*');
     end;
  End;

Begin
  TotalWidth:=0;
  for Cols:= 1 to Cols do
    Inc(TotalWidth,BestWidth[Cols]);
  for Rows:= 1 to Rows do
    if BestHeight[Rows] = 0 then Inc(BestHeight[Rows]);
  Assign(F,OutFileName); Append(F);
  for Row:= 1 to Rows do
    begin
      PrintLine;
      PrintRow;
    end;
  PrintLine;
  WriteLn(F);
  Close(F);
End;


Procedure FreeAllocatedMemory;
Begin
  for Rows:= 1 to Rows do
    for Cols:= 1 to Cols do
      if T[Rows,Cols] <> nil then
        DisposeKletka(T[Rows,Cols]);
End;


BEGIN
  Assign(F,OutFileName); Rewrite(F); Close(F);
  Assign(F,InFileName); Reset(F);
  repeat
    ReadTable;
    CalculateOptimalWidthAndHeight;
    PrintTable;
    FreeAllocatedMemory;
  until SeekEOF(F);
  Close(F);
END.
